package net.wapro.secsample.ejb;

import java.util.List;

import javax.annotation.Resource;
import javax.annotation.security.DeclareRoles;
import javax.annotation.security.PermitAll;
import javax.annotation.security.RolesAllowed;
import javax.ejb.LocalBean;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.inject.Inject;

/**
 * Session Bean implementation class SecureService
 */
@Stateless
@LocalBean
@DeclareRoles({"LevelHigh","LevelLow"})
public class SecretNewsService {

	@Inject
	NewsDao newsDao;

	@Resource
	SessionContext ctx;


    public SecretNewsService() {

    }

    @RolesAllowed({"LevelHigh"})
    public List<?> getAllSecretNews4High() {
    	return newsDao.getHighNews();
    }

    @RolesAllowed({"LevelLow"})
    public List<?> getAllSecretNews4Low() {
    	return newsDao.getHighNews();
    }

    @RolesAllowed({"LevelHigh","LevelLow"})
    public List<?> getAllSecretNews() {
    	return newsDao.getHighLowNews();
    }

    @PermitAll
    public String getCallerName() {
    	String name = null;
    	if(ctx.getCallerPrincipal() != null) {
    		name = ctx.getCallerPrincipal().getName();
    	}

    	return name;
    }


}

