package net.wapro.secsample.web.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.HttpConstraint;
import javax.servlet.annotation.ServletSecurity;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 *
 * @author awagner73
 */
@SuppressWarnings("serial")
@WebServlet(name = "AllSecServlet", urlPatterns = {"/allSecServlet"})
@ServletSecurity(
        @HttpConstraint(
            rolesAllowed={"LevelHigh","LevelLow"}
        )
)
public class AllSecServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP
     * <code>GET</code> and
     * <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {

            out.println("<html>");
            out.println("<head>");
            out.println("<title>ALL Servlet SecServlet</title>");
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>All Levels Security Servlet at " + request.getContextPath() + "</h1>");
            out.println("<br>");
            out.println("AuthType:["+request.getAuthType()+"]");
            out.println("<br>");

            out.println("RemoteUser:["+request.getRemoteUser()+"]");
            out.println("<br>");
            if(request.getUserPrincipal()!= null) {
                out.println("UserPrincipal.Name:["+request.getUserPrincipal().getName()+"]");
            } else {
                out.println("no principal");
            }

            out.println("</hr>");

            out.println("</body>");
            out.println("</html>");
        } finally {
            out.close();
        }
    }

    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Secured Servlet only for HighLevel and LowLevel -Roles";
    }
}
